unit DlgDriver;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, VCap, Dialogs;

type
  TDriverDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    GroupBox1: TGroupBox;
    CompressorBox: TComboBox;
    GroupBox2: TGroupBox;
    DeviceBox: TComboBox;
    GroupBox3: TGroupBox;
    NameBox: TComboBox;
    DisconnectDevice: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DisconnectDeviceClick(Sender: TObject);
    procedure DeviceBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DriverDlg: TDriverDlg;

implementation

uses MICAMMainUnit, MICAMUtils;

{$R *.DFM}

procedure TDriverDlg.FormCreate(Sender: TObject);
var
  StringList : TStringList;
begin
  StringList := GetVideoDevicesList;
  DeviceBox.Clear;
   try
     DeviceBox.Items.Assign(StringList);
   finally
     Stringlist.Free;
   end;
  StringList := GetVideoCompressorsList;
  Compressorbox.Clear;
   try
     Compressorbox.Items.Assign(StringList);
     Compressorbox.Items.Add('None')
   finally
     Stringlist.Free;
   end;
end;

procedure TDriverDlg.FormShow(Sender: TObject);
var
  i : Integer;
begin
   Main.Vidcap.Init;
   FormCreate(nil);

   for i:= 0 to DeviceBox.Items.Count -1 do
     begin
     if DeviceBox.Items[i]=Main.VideoDevice then
        begin
        DeviceBox.ItemIndex:=i;
        Break;
        end;
     end;
   for i:= 0 to CompressorBox.Items.Count -1 do
     begin
     if CompressorBox.Items[i]=Main.Compressor then
        begin
        CompressorBox.ItemIndex:=i;
        Break;
        end;
     end;
   if Main.NrofMicroscopes <>0 then
     begin
     Namebox.Clear;
     for i:=0 to Main.NrofMicroscopes-1 do
         begin
         Namebox.Items.Add(Main.Microscope[i].Name);
         end;
     Namebox.ItemIndex:=Main.SelectedMic;
     end;
end;

procedure TDriverDlg.OKBtnClick(Sender: TObject);
begin
  Main.SelectedMic:=Namebox.ItemIndex;
  Main.SetObjectives(Main.SelectedMic,Main.DefaultObj);
  ModalResult:=mrOK;
end;

procedure TDriverDlg.DisconnectDeviceClick(Sender: TObject);
begin
  With Main do
    begin
      VidCap.StopPreview;
      VidCap.StopCapture;
      //VidCap.SaveGraph(config);
      //config.ACapSource:='';
     // config.VCapSource:='';
      //config.VComp:='';
      //VidCap.RestoreGraph(config);
     Vidcap.OnChangeDevice(nil);
     // Vidcap.Destroy;
      Vidcap.Free;
      MakeVidcap;
    end;
  FormCreate(nil);
  ModalResult:=mrCancel;
end;

procedure TDriverDlg.DeviceBoxChange(Sender: TObject);
var
 I : Integer;
begin
 LoadCameraInfo(Devicebox.Text);
 Namebox.ItemIndex:=Main.DefaultMic;
 for i:= 0 to CompressorBox.Items.Count -1 do
     begin
     if CompressorBox.Items[i]=Main.Compressor then
        begin
        CompressorBox.ItemIndex:=i;
        Break;
        end;
     end;
end;

end.
