{
This File is based on an article from:
http://delphi.about.com/library/weekly/aa051600a.htm

********************************************
Zarko Gajic
About.com Guide to Delphi Programming
http://delphi.about.com
email: delphi.guide@about.com
********************************************
}
unit SearchUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg, FileCtrl;

type
  TSearchForm = class(TForm)
    FileList: TListBox;
    FotoDirEdit: TEdit;
    SearchButton: TButton;
    FileSearchEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    lblNumberFound: TLabel;
    SelectDir: TButton;
    OpenDialog1: TOpenDialog;
    Next: TButton;
    Previous: TButton;
    ShowList: TListBox;
    CloseButton: TButton;
    Open: TButton;
    Database: TGroupBox;
    SearchEdit: TEdit;
    DatabaseBox: TComboBox;
    LocalNames: TCheckBox;
    UseSearchName: TButton;
    Label3: TLabel;
    Names: TListBox;
    Label5: TLabel;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    Name1Edit: TEdit;
    Name2Edit: TEdit;
    Rename1: TButton;
    Rename2: TButton;
    GroupBox2: TGroupBox;
    FileNameEdit: TEdit;
    DirEdit: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
    Image: TImage;
    procedure SearchButtonClick(Sender: TObject);
    procedure FileListDblClick(Sender: TObject);
    procedure SelectDirClick(Sender: TObject);
    procedure OpenImage(Filename:String);
    procedure NextClick(Sender: TObject);
    procedure PreviousClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShowListClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SearchClick(Sender: TObject);
    procedure SearchEditChange(Sender: TObject);
    procedure DatabaseBoxChange(Sender: TObject);
    procedure NamesClick(Sender: TObject);
    procedure UseSearchNameClick(Sender: TObject);
    procedure LocalNamesClick(Sender: TObject);
    procedure Rename2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileSearchEditChange(Sender: TObject);
    procedure SearchEditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure FileSearch(const PathName, FileName : string; const InDir : boolean);
    procedure DBSearch(const PathName, FileName : string);
    procedure LoadDB(naam: String);
    procedure FindUniqueName(Str:String);
    function FindDate(Str:String): String;
  public
    { Public declarations }
  end;

var
  SearchForm: TSearchForm;
  Teller: Integer;

implementation
{$R *.DFM}

Uses MICAMMainUnit;

var
 NedLines: TStrings;
 LatLines: TStrings;
 Number : Integer;

procedure TSearchForm.FormCreate(Sender: TObject);
begin
  NedLines:=TStringlist.Create;
  LatLines:=TStringlist.Create;
  DatabaseBox.Clear;
  OpenDialog1.InitialDir:=Main.FrameDir;
  FotoDirEdit.Text:=Main.FrameDir;
  DBSearch(Main.ProgDir,'Databases\*.csv');
  DatabaseBox.ItemIndex:=0;
  LoadDB(DatabaseBox.Items.Strings[DatabaseBox.ItemIndex]);
  SearchEdit.Text:='';
  SearchClick(nil);
  Teller:=0;
end;

procedure TSearchForm.FileSearch(const PathName, FileName : string; const InDir : boolean);
var Rec  : TSearchRec;
    Path, Ext : string;
begin
Path := IncludeTrailingBackslash(PathName);
if FindFirst(Path + FileName, faAnyFile - faDirectory, Rec) = 0 then
 try
   repeat
     Ext:=lowerCase(ExtractFileExt(Rec.Name));
     if (Ext='.bmp') or (Ext='.jpg') or(Ext='.png')then
       begin
       FileList.Items.Add(Path + Rec.Name);
       ShowList.Items.Add(Rec.Name);
       end;
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;

If not InDir then Exit;

if FindFirst(Path + '*.*', faDirectory, Rec) = 0 then
 try
   repeat
    if ((Rec.Attr and faDirectory) <> 0)  and (Rec.Name<>'.') and (Rec.Name<>'..') then
     FileSearch(Path + Rec.Name, FileName, True);
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;
end;

procedure TSearchForm.SearchButtonClick(Sender: TObject);
begin
  FileSearchEditChange(nil);
  FileList.SetFocus;
end;

procedure TSearchForm.FileSearchEditChange(Sender: TObject);
var
 i : Integer;
begin
  FileList.Clear;
  ShowList.Clear;
  DirEdit.Text:='';
  FileNameEdit.Text:='';
  lblNumberFound.Caption:=Inttostr(FileList.Items.Count) + ' files found.';
  FileSearch(FotoDirEdit.Text, '*'+FileSearchEdit.Text+'*.*', True);
  lblNumberFound.Caption:=Inttostr(FileList.Items.Count) + ' files found.';
end;

procedure TSearchForm.FileListDblClick(Sender: TObject);
var SelectedFile : string;
    Rec          : TSearchRec;
begin
SelectedFile := FileList.Items.Strings[ShowList.ItemIndex];
if FindFirst(SelectedFile, faAnyFile, Rec) = 0 then
  begin
   Teller:=ShowList.Itemindex;
   OpenImage(SelectedFile);
   FindClose(Rec)
  end;
end;

procedure TSearchForm.SelectDirClick(Sender: TObject);
var
  i : Integer;
  dir: String;
  options : TSelectDirOpts;
begin
 SearchEdit.Text:='';
 Dir:=OpenDialog1.InitialDir;
 if SelectDirectory(Dir, options, 0) then
    begin
    OpenDialog1.InitialDir:=Dir;
    FotoDirEdit.Text:=OpenDialog1.InitialDir;
    end;
 SearchButtonClick(nil);
end;

procedure TSearchForm.OpenImage(Filename:String);
var
i : Integer;
Ext: String;
begin
 Ext:=lowerCase(ExtractFileExt(FileName));
 if (Ext='.bmp') or (Ext='.jpg') or(Ext='.png')then
    begin
    Teller:=ShowList.ItemIndex;
    ShowListClick(nil);
    end;
end;

procedure TSearchForm.NextClick(Sender: TObject);
var
  Ext: String;
begin
  repeat
    Inc(Teller);
    if Teller=FileList.Count then Teller:=0;
    ShowList.Selected[Teller]:=True;
    FileList.Selected[Teller]:=True;
    Ext:=lowerCase(ExtractFileExt(FileList.Items[Teller]));
    until (Ext='.bmp') or (Ext='.jpg') or(Ext='.png');
  ShowListClick(nil);
end;

procedure TSearchForm.PreviousClick(Sender: TObject);
var
 Ext: String;
begin
  repeat
    Dec(Teller);
    if Teller=-1 then Teller:=FileList.Count-1;
    ShowList.Selected[Teller]:=True;
    FileList.Selected[Teller]:=True;
    Ext:=lowerCase(ExtractFileExt(FileList.Items[Teller]));
    until (Ext='.bmp') or (Ext='.jpg') or(Ext='.png');
  ShowListClick(nil);
end;

procedure TSearchForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_Next then NextClick(nil);
  if Key=VK_Prior then PreviousClick(nil);
end;

procedure TSearchForm.ShowListClick(Sender: TObject);
begin
 FileNameEdit.Text:=ExtractFileName(FileList.Items[ShowList.Itemindex]);
 DirEdit.Text:=ExtractFilePath(FileList.Items[ShowList.Itemindex]);
 Name1Edit.Text:='';
 Name2Edit.Text:='';
 Teller:=ShowList.ItemIndex;
 Caption:=FileList.Items[Teller];
 Image.Picture.LoadFromFile(FileList.Items[Teller]);
end;

procedure TSearchForm.CloseButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TSearchForm.OpenClick(Sender: TObject);
begin
 Main.OpenImgFile(FileList.Items[Teller]);
 Close;
end;

procedure TSearchForm.Rename1Click(Sender: TObject);
var
  i : Integer;
begin
 if FileExists(DirEdit.Text+Name1Edit.Text) then
     if MessageDlg('A file with this name exists!'+#10#13+'Do you want to overwrite this file?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then Exit;
 RenameFile(DirEdit.Text+FileNameEdit.Text,DirEdit.Text+Name1Edit.Text);
 i:=ShowList.Itemindex;
 SearchButtonClick(nil);
 Teller:=i;
 ShowList.Selected[Teller]:=True;
 FileList.Selected[Teller]:=True;
 ShowListClick(nil);
end;

procedure TSearchForm.Rename2Click(Sender: TObject);
var
  i : Integer;
begin
 if FileExists(DirEdit.Text+Name2Edit.Text) then
     if MessageDlg('A file with this name exists!'+#10#13+'Do you want to overwrite this file?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then Exit;
 RenameFile(DirEdit.Text+FileNameEdit.Text,DirEdit.Text+Name2Edit.Text);
 i:=ShowList.Itemindex;
 SearchButtonClick(nil);
 Teller:=i;
 ShowList.Selected[Teller]:=True;
 FileList.Selected[Teller]:=True;
 ShowListClick(nil);
end;

procedure TSearchForm.DBSearch(const PathName, FileName : string);
var Rec  : TSearchRec;
    Path : string;
begin
Path := IncludeTrailingPathDelimiter(PathName);
if FindFirst(Path + FileName, faAnyFile - faDirectory, Rec) = 0 then
 try
   repeat
     DatabaseBox.Items.Add(Rec.Name);
   until FindNext(Rec) <> 0;
 finally
   FindClose(Rec);
 end;
end;

procedure TSearchForm.LoadDB(naam: String);
var
 i, k, Lengte : Integer;
 S : String;
begin
  if naam='' then exit;
  NedLines.Clear;
  LatLines.Clear;
  NedLines.LoadFromFile(Main.ProgDir+'\Databases\'+naam);
  for i:=0 to NedLines.Count-1 do
     begin
     S:=NedLines[i];
     Lengte:=Length(S);
     k:=Pos(';',S);
     LatLines.Add(Copy(S,k+1,Lengte));
     Delete(S,k,Lengte);
     NedLines[i]:=S;
     end;
end;

procedure TSearchForm.SearchClick(Sender: TObject);
var
 i,k :Integer;
begin
 Names.Clear;

 if SearchEdit.Text=''
    then begin
         if LocalNames.Checked
         then for i:=0 to NedLines.Count-1 do
                  if Nedlines[i]<>'' then Names.Items.Add(Nedlines[i])
                                     else
         else for i:=0 to LatLines.Count-1 do
                  Names.Items.Add(Latlines[i]);
         Names.Sorted:=True;
         exit;
         end;
  k:=0;

  if LocalNames.Checked
  then
      begin
      for i:=0 to NedLines.Count-1 do
        begin
        if k>100 then continue;
        if Pos(lowercase(SearchEdit.Text),lowercase(nedLines[i]))<>0 then
           Names.Items.Add(Nedlines[i]);
        end;
      end
   else
      begin
      for i:=0 to LatLines.Count-1 do
        begin
        if k>100 then continue;
        if Pos(lowercase(SearchEdit.Text),lowercase(LatLines[i]))<>0 then
           Names.Items.Add(Latlines[i]);
        end;
      end;
   Names.Sorted:=True;
end;

procedure TSearchForm.SearchEditChange(Sender: TObject);
begin
 SearchClick(nil);
end;

procedure TSearchForm.DatabaseBoxChange(Sender: TObject);
begin
  LoadDB(DatabaseBox.Items.Strings[DatabaseBox.ItemIndex]);
  SearchEdit.Text:='';
  SearchClick(nil);
end;

procedure TSearchForm.NamesClick(Sender: TObject);
var
  Str, Ext, Dstr : String;
begin
    Ext:=ExtractFileExt(FileNameEdit.Text);
    if Names.ItemIndex>=0
       then Str:=Names.Items[Names.ItemIndex]
       else Str:=SearchEdit.Text;
    // Suggested Name 1
    Dstr:=FindDate(FilenameEdit.Text);
    if Dstr='' then Name1Edit.Text:=Str+Ext
               else Name1Edit.Text:=Str+'_'+Dstr;
    // Suggested Name 2
    DateSeparator := '-';
    ShortDateFormat := 'yyy/mm/dd';
    Str:=Str+'_'+DateToStr(Main.SampleDate);
    FindUniqueName(Str);
    Str:=Str+'_'+FormatFloat('0000',Number)+Ext;
    Name2Edit.Text:= Str;
end;

procedure TSearchForm.UseSearchNameClick(Sender: TObject);
begin
  Names.ItemIndex:=-1;
  NamesClick(nil);
end;

procedure TSearchForm.LocalNamesClick(Sender: TObject);
begin
   SearchEdit.Text:='';
   SearchClick(nil);
end;

procedure TSearchForm.FindUniqueName(Str:String);
var
 Testname,Ext : String;
begin
  Ext:=ExtractFileExt(FileNameEdit.Text);
  Number:=0;
  repeat
    TestName:=DirEdit.Text+Str;
    inc(Number);
    TestName:=TestName+'_'+FormatFloat('0000',Number)+Ext;
  until (not FileExists(TestName)) or (Number>9999);
end;

function TSearchForm.FindDate(Str: String): String;
var
  i : Integer;
begin
  Result:='';
  if Pos('-',Str)<>0 then
    begin
      i:=Pos('-',Str);
      if (Str[i+3]='-') then
         Result:=Copy(Str,i-4,Length(Str));
    end;
end;

procedure TSearchForm.FormShow(Sender: TObject);
begin
 SearchButtonClick(nil);
 if FileList.Count>0 then FileList.Selected[Teller]:=True;
 if ShowList.Count>0 then ShowList.Selected[Teller]:=True;
end;

procedure TSearchForm.SearchEditMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SearchEdit.Text:='';
  SearchClick(nil);
end;

end.
