unit Serial;


interface

uses
  Windows, SysUtils;

  procedure InitOverlapped(var Overlapped : TOverlapped);
  function OpenCOM(Port: byte): boolean;
  procedure CloseCOM;
  Function CTS : boolean;
  Function DSR : boolean;
  Function RI : boolean;
  Function DCD : boolean;
  procedure DTR(value:Boolean);
  procedure RTS(value:Boolean);

var
  PortTimeout : _COMMTIMEOUTS;
  PortHandle : Integer;
  PortDCB : TDCB;
  PortNr  : Integer;
  PortState : Cardinal;
  WriteOverlapped,ReadOverlapped,StatusOs: TOverlapped;

implementation

procedure InitOverlapped(var Overlapped : TOverlapped);
begin
  Overlapped.Offset := 0;
  Overlapped.OffsetHigh := 0;
  Overlapped.Internal := 0;
  Overlapped.InternalHigh := 0;
  Overlapped.hEvent := CreateEvent(nil,True,False,'');
end;

function OpenCOM(Port: byte): boolean;
begin
  PortHandle :=
  CreateFile(PChar('\\.\COM'+IntToStr(Port)),GENERIC_READ or GENERIC_WRITE,0,
             nil,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,LongInt(0));
  
  //Overlapped = Asynchron auf Microsoftianisch
 
  {Da wir nun asynchron auf die Schnittstelle zugreifen (weiss der Teufel 
  warum  aber es sieht so aus als wre diese Art des Zugriffs ab W2K
  praktisch ZWINGEND notwendig  selbst wenn man gar nicht asynchron bertragen will)  
  muss man auch die dafr notwendigen Structs initialisieren}  
  if PortHandle > 0 then
  begin
    Result := true;
    InitOverlapped(WriteOverlapped);
    InitOverlapped(ReadOverlapped);
    InitOverlapped(StatusOs);
  end else Result := false;
end;

procedure CloseCOM;
begin
  PurgeComm(PortHandle, PURGE_RXABORT or PURGE_RXCLEAR or PURGE_TXABORT or PURGE_TXCLEAR);
  SetCommMask(PortHandle,0); //unterbricht WaitCommEvent im Polling thread
  CloseHandle(PortHandle);
  PortHandle := 0;
end;

Function CTS : boolean;
var PortState: cardinal;
begin
GetCommModemStatus(PortHandle,PortState); //PortHandle erhlt man mit CreateFile
//Nun die Abfrage  Hier auf Clear to send
if ((Portstate and MS_CTS_ON) <> 0) then Result := true
    else Result := false;
end;

Function DSR : boolean;
var PortState: cardinal;
begin
GetCommModemStatus(PortHandle,PortState); //PortHandle erhlt man mit CreateFile
//Nun die Abfrage
if ((Portstate and MS_DSR_ON) <> 0) then Result := true
    else Result := false;
end;

Function RI : boolean;
var PortState: cardinal;
begin
GetCommModemStatus(PortHandle,PortState); //PortHandle erhlt man mit CreateFile
if ((Portstate and MS_RING_ON) <> 0) then Result := true
    else Result := false;
end;

Function DCD : boolean;
var PortState: cardinal;
begin
GetCommModemStatus(PortHandle,PortState); //PortHandle erhlt man mit CreateFile
if ((Portstate and MS_RLSD_ON) <> 0) then Result := true
    else Result := false;
end;


//Um RTS, DTR, XOFF, XON oder einen Break zu setzen oder zurckzusetzen
//benutzt man die Funktion EscapeCommFunction:

procedure DTR(value:Boolean);
begin
  if Value=False 
     then begin
          if (PortHandle <> 0) then EscapeCommFunction(PortHandle,CLRDTR)
          end
	   else if (PortHandle <> 0) then EscapeCommFunction(PortHandle,SETDTR);
end;

procedure RTS(value:Boolean);
begin
  if Value=False 
     then begin
          if (PortHandle <> 0) then EscapeCommFunction(PortHandle,CLRRTS)
          end
	   else if (PortHandle <> 0) then EscapeCommFunction(PortHandle,SETRTS);
end;

end.
